<?xml version="1.0"?>

<!--******************************************************************--> 
<!-- Basic Logic                                                      -->
<!-- First draft: April 3 2000                                        -->
<!-- HELM Group: Asperti, Padovani, Sacerdoti, Schena                 -->
<!--******************************************************************-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                              xmlns:m="http://www.w3.org/1998/Math/MathML"
                              xmlns:helm="http://www.cs.unibo.it/helm">

<!--******************************************************************-->
<!-- Variable containing the absolute path of the CIC file            -->
<!--******************************************************************-->

<xsl:variable name="absPath">http://localhost:8081/getciconly?uri=</xsl:variable>

<!-- ************************* LOGIC *********************************-->

<!-- Proof objects -->

<!-- <xsl:key name="typeid" use="@of" match="TYPE"/> -->

<!-- ALL this elements does not have inner type -->
<xsl:template match="PROD|REL|SORT|VAR|META|CONST|MUTIND|MUTCONSTRUCT" mode="noannot">
<xsl:apply-templates select="." mode="pure"/>
</xsl:template>

<!-- LAMBDA has inner type only if it is not nested inside another lambda -->
<xsl:template match="LAMBDA" mode="noannot">
 <xsl:variable name="id" select="@id"/>
 <xsl:choose>
  <xsl:when test="//InnerTypes and @sort='Prop' and name(../..) != 'LAMBDA'">
  <!-- <xsl:when test="@sort='Prop' and //InnerTypes/TYPE[@of=$id]"> -->
   <xsl:call-template name="has_inner_type"/>
  </xsl:when>
  <xsl:otherwise>
   <xsl:apply-templates select="." mode="pure"/>
  </xsl:otherwise>
 </xsl:choose>
</xsl:template>

<!-- ALL this elements have inner type -->
<xsl:template match="CAST|APPLY|MUTCASE|FIX|COFIX" mode="noannot">
 <xsl:choose>
  <!-- <xsl:when test="//InnerTypes and key('typeid',@id)"> -->
  <!-- <xsl:when test="//InnerTypes/TYPE[@of=$id]"> -->
  <xsl:when test="//InnerTypes and @sort='Prop'">
   <xsl:call-template name="has_inner_type"/>
  </xsl:when>
  <xsl:otherwise>
   <xsl:apply-templates select="." mode="pure"/>
  </xsl:otherwise>
 </xsl:choose>
</xsl:template>

<xsl:template name="has_inner_type">
   <xsl:variable name="id" select="@id"/>
   <xsl:choose>
    <xsl:when test="name()= 'APPLY' and CONST[
 attribute::uri='cic:/Coq/Init/Logic_Type/eqT_ind.con' or
 attribute::uri='cic:/Coq/Zarith/auxiliary/eqT_ind_r.con'] and count(child::*) = 7">
     <m:apply helm:xref="{@id}">
      <m:csymbol>thread</m:csymbol>
      <xsl:apply-templates mode="pure" select="//InnerTypes/TYPE[@of=$id]/*"/>
      <m:apply>
       <m:csymbol>rw_step</m:csymbol>
       <xsl:apply-templates mode="pure" select="*[3]"/>
       <xsl:apply-templates mode="pure" select="*[6]"/>
       <xsl:apply-templates mode="pure" select="*[7]"/>
      </m:apply>
      <xsl:apply-templates mode="thread" select="*[5]"/>
     </m:apply>
    </xsl:when>
    <!-- aggiungere la verifica dell'esistenza dei lambda per and_ind -->
    <xsl:when test="name()= 'APPLY' and CONST[
 attribute::uri='cic:/Coq/Init/Logic/Conjunction/and_ind.con'] 
 and count(child::*) = 6">
     <m:apply helm:xref="{@id}">
      <m:csymbol>and_ind</m:csymbol>
      <xsl:apply-templates mode="noannot" select="*[6]"/>
      <m:ci><xsl:call-template name="insert_subscript"><xsl:with-param name="node_value"><xsl:value-of select="*[5]/target/@binder"/></xsl:with-param></xsl:call-template></m:ci>
      <xsl:apply-templates mode="pure" select="*[5]/source/*"/>
      <m:ci><xsl:call-template name="insert_subscript"><xsl:with-param name="node_value"><xsl:value-of select="*[5]/target/LAMBDA/target/@binder"/></xsl:with-param></xsl:call-template></m:ci>
      <xsl:apply-templates mode="pure" select="*[5]/target/LAMBDA/source/*"/>
      <xsl:apply-templates mode="noannot" select="*[5]/target/LAMBDA/target/*"/>
     </m:apply>
    </xsl:when>
    <xsl:when test="name()= 'APPLY' and CONST[
 attribute::uri='cic:/Coq/Init/Logic/Disjunction/or_ind.con'] 
 and count(child::*) = 7">
     <m:apply helm:xref="{@id}">
      <m:csymbol>or_ind</m:csymbol>
      <xsl:apply-templates mode="noannot" select="*[7]"/>
      <xsl:apply-templates mode="pure" select="//InnerTypes/TYPE[@of=$id]/*"/>
      <xsl:apply-templates mode="pure" select="*[5]"/>
      <xsl:apply-templates mode="pure" select="*[6]"/>
     </m:apply>
    </xsl:when>
    <!-- <xsl:when test="count(*[@id = //InnerTypes/TYPE/@of]) = 1"> -->
    <xsl:when test="count(*[@sort='Prop' and (name(.)='LAMBDA' or name(.)='LETIN' or name(.)='APPLY' or name(.)='MUTCASE' or name(.)='FIX' or name(.)='COFIX')]) = 1">
     <m:apply helm:xref="{@id}">
      <m:csymbol>thread</m:csymbol>
      <xsl:apply-templates mode="pure" select="//InnerTypes/TYPE[@of=$id]/*"/>
      <m:apply>
       <m:csymbol>app</m:csymbol>
       <xsl:apply-templates mode="copy-of-no-prop" select="*[1]"/>
      </m:apply>
      <xsl:apply-templates mode="thread" select="*[@sort='Prop' and (name(.)='LAMBDA' or name(.)='LETIN' or name(.)='APPLY' or name(.)='MUTCASE' or name(.)='FIX' or name(.)='COFIX')]"/>
     </m:apply>
    </xsl:when>
    <xsl:otherwise>
     <m:apply helm:xref="{@id}">
      <m:csymbol>proof</m:csymbol>
      <xsl:apply-templates select="." mode="pure"/>
      <!-- <xsl:apply-templates select="key('typeid',@id)" mode="pure"/> -->
      <xsl:apply-templates select="//InnerTypes/TYPE[@of=$id]/*" mode="pure"/>
     </m:apply>
    </xsl:otherwise>
   </xsl:choose>
</xsl:template>

<xsl:template match="*" mode="copy-of-no-prop">
 <xsl:choose>
  <!-- <xsl:when test="@id = //InnerTypes/TYPE/@of"> -->
  <xsl:when test="@sort='Prop' and (name(.)='LAMBDA' or name(.)='LETIN' or name(.)='APPLY' or name(.)='MUTCASE' or name(.)='FIX' or name(.)='COFIX')">
   <m:ci>previous</m:ci>
  </xsl:when>
  <xsl:otherwise>
   <xsl:apply-templates select="." mode="pure"/>
  </xsl:otherwise>
 </xsl:choose>
 <xsl:apply-templates mode="copy-of-no-prop" select="following-sibling::*[1]"/>
</xsl:template>

<xsl:template match="*" mode="thread">
  <xsl:choose>
   <xsl:when test="name()= 'APPLY' and CONST[
 attribute::uri='cic:/Coq/Init/Logic_Type/eqT_ind.con' or
 attribute::uri='cic:/Coq/Zarith/auxiliary/eqT_ind_r.con'] and count(child::*) = 7">
    <xsl:variable name="id" select="@id"/>
     <xsl:apply-templates mode="pure" select="//InnerTypes/TYPE[@of=$id]/*"/>
     <m:apply>
      <m:csymbol>rw_step</m:csymbol>
      <xsl:apply-templates mode="pure" select="*[3]"/>
      <xsl:apply-templates mode="pure" select="*[6]"/>
      <xsl:apply-templates mode="pure" select="*[7]"/>
     </m:apply>
     <xsl:apply-templates mode="thread" select="*[5]"/>
   </xsl:when>
<!--**** Patch temporanea, per il problema dei threads ***-->
<xsl:when test="(name()= 'APPLY' and CONST[
 attribute::uri='cic:/Coq/Init/Logic/Conjunction/and_ind.con'] 
 and count(child::*) = 6) or
(name()= 'APPLY' and CONST[
 attribute::uri='cic:/Coq/Init/Logic/Disjunction/or_ind.con'] 
 and count(child::*) = 7)">
 <xsl:apply-templates mode="noannot" select="."/>
</xsl:when>
<!--**** Fine Patch temporanea, per il problema dei threads ***-->
   <xsl:when test="//InnerTypes and count(*[@sort='Prop' and (name(.)='LAMBDA' or name(.)='LETIN' or name(.)='APPLY' or name(.)='MUTCASE' or name(.)='FIX' or name(.)='COFIX')]) = 1">
       <xsl:variable name="id" select="@id"/>
       <m:apply helm:xref="{@id}">
        <m:csymbol>thread</m:csymbol>
        <xsl:apply-templates mode="pure" select="//InnerTypes/TYPE[@of=$id]/*"/>
        <m:apply>
         <m:csymbol>app</m:csymbol>
         <xsl:apply-templates mode="copy-of-no-prop" select="*[1]"/>
        </m:apply>
        <!-- <xsl:apply-templates mode="thread" select="*[@id = //InnerTypes/TYPE/@of]"/> -->
        <xsl:apply-templates mode="thread" select="*[@sort='Prop' and (name(.)='LAMBDA' or name(.)='LETIN' or name(.)='APPLY' or name(.)='MUTCASE' or name(.)='FIX' or name(.)='COFIX')]"/>
       </m:apply>
   </xsl:when>
   <xsl:otherwise>
    <xsl:apply-templates mode="noannot" select="."/>
   </xsl:otherwise>
  </xsl:choose>
</xsl:template>


<!-- Basic proof operators -->

<!-- non del tutto soddisfacente, ma .... -->
<xsl:template match="APPLY[CONST[
 attribute::uri='cic:/Coq/Init/Logic_Type/eqT_ind.con' or
 attribute::uri='cic:/Coq/Zarith/auxiliary/eqT_ind_r.con']]" mode="appflat">
    <xsl:choose>
     <xsl:when test="count(child::*) > 7">
      <xsl:variable name="id" select="@id"/>
      <xsl:variable name="ideqp" select="*[7]/@id"/>
      <xsl:variable name="idsubp" select="*[5]/@id"/>
<!--
      <xsl:variable name="leteqp" select="boolean(//InnerTypes/TYPE[@of=$ideqp])"/>
      <xsl:variable name="letsubp" select="boolean(//InnerTypes/TYPE[@of=$idsubp])"/>
-->
      <xsl:variable name="leteqp" select="boolean(*[7][@sort='Prop' and (name(.)='LAMBDA' or name(.)='LETIN' or name(.)='APPLY' or name(.)='MUTCASE' or name(.)='FIX' or name(.)='COFIX')])"/>
      <xsl:variable name="letsubp" select="boolean(*[5][@sort='Prop' and (name(.)='LAMBDA' or name(.)='LETIN' or name(.)='APPLY' or name(.)='MUTCASE' or name(.)='FIX' or name(.)='COFIX')])"/>
      <m:apply helm:xref="{@id}">
       <m:csymbol>rewrite_and_apply</m:csymbol>
       <m:apply>
        <m:csymbol>rw_step</m:csymbol>
        <xsl:apply-templates mode="pure" select="*[3]"/>
        <xsl:apply-templates mode="pure" select="*[6]"/>
        <xsl:choose>
         <xsl:when test="$leteqp">
          <xsl:choose>
           <xsl:when test="$letsubp">
            <m:ci>
             <xsl:call-template name="insert_subscript"><xsl:with-param name="node_value"><xsl:value-of select="'h2'"/></xsl:with-param></xsl:call-template>
            </m:ci>
           </xsl:when>
           <xsl:otherwise>
            <m:ci>
             <xsl:call-template name="insert_subscript"><xsl:with-param name="node_value"><xsl:value-of select="'h1'"/></xsl:with-param></xsl:call-template>
            </m:ci>
           </xsl:otherwise>
          </xsl:choose>
         </xsl:when>
         <xsl:otherwise>
          <xsl:apply-templates mode="pure" select="*[7]"/>
         </xsl:otherwise>
        </xsl:choose>
       </m:apply>
      <xsl:choose>
       <xsl:when test="$letsubp">
        <m:ci>
         <xsl:call-template name="insert_subscript"><xsl:with-param name="node_value"><xsl:value-of select="'h1'"/></xsl:with-param></xsl:call-template>
        </m:ci>
       </xsl:when>
       <xsl:otherwise>
        <xsl:apply-templates mode="pure" select="*[5]"/>
       </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates mode="flat" select="*[8]">
       <xsl:with-param name="n">
        <xsl:value-of select="1+$letsubp+$leteqp"/>
       </xsl:with-param>
      </xsl:apply-templates>
     </m:apply>
    </xsl:when>
    <xsl:otherwise>
     <m:apply helm:xref="{@id}">
      <m:csymbol>app</m:csymbol>
      <xsl:apply-templates mode="flat" select="*[1]"/>
     </m:apply>
    </xsl:otherwise>
   </xsl:choose>
</xsl:template> 

<xsl:template match="APPLY[CONST[
 attribute::uri='cic:/Coq/Init/Logic/Conjunction/and_ind.con']]" mode="appflat">
    <xsl:choose>
     <xsl:when test="count(child::*) > 4">
      <m:apply helm:xref="{@id}">
       <m:csymbol>app</m:csymbol>
       <xsl:apply-templates mode="pure" select="*[1]"/>
       <m:ci>*</m:ci>
       <m:ci>*</m:ci>
       <m:ci>*</m:ci>
       <xsl:apply-templates mode="flat" select="*[5]"/>
      </m:apply>
     </xsl:when>
     <xsl:otherwise>
      <m:apply helm:xref="{@id}">
       <m:csymbol>app</m:csymbol>
       <xsl:apply-templates mode="flat" select="*[1]"/>
      </m:apply>
     </xsl:otherwise>
    </xsl:choose>
</xsl:template> 


</xsl:stylesheet>






